#pragma once

#include <Base_DAQ_Observer.h>
#include <hiredis/hiredis.h>

#include <atomic>
#include <thread>
#include <mutex>
#include <condition_variable>

namespace inaf::oasbo::DAQ_observers {
class AstriRedisDAQObserver: public BaseDAQ_Observer {
protected:
	redisContext *context = nullptr;
	std::string ip{};
	int port;

	std::atomic<bool> stopFlag = false;
	std::mutex writeStatsMutex, sleepMutex;
	std::thread observerThread;
	std::condition_variable sleep_cv;
	int updateInterval;
	void updateThread();

public:
	AstriRedisDAQObserver(inaf::oasbo::DAQ::BaseDAQ *dataAcquisition,std::string ip, int port);
	~AstriRedisDAQObserver();

	void updatePacketStats();
	void updateArchiverStats();
	void updateProviderStats();
	void updateReceiverStats();
	void updateAll();
	void start();
	void stop();
};
}
